#include <stdio.h>
#include <allegro.h>

int main()
{
   DATAFILE *dat, *d;
   PACKFILE *f;
   int c;

   install_allegro(SYSTEM_NONE, &errno, atexit);

   printf("\nTesting datafile access methods:\n");

   /* try loading the whole thing */
   printf("\nTesting load_datafile(\"test.dat\")\n");
   dat = load_datafile("test.dat");

   if (dat) {
      d = &dat[1];
      if (d)
	 printf("msg = '%s'\n", d->dat);
      else
	 printf("msg not found!\n");

      d = (DATAFILE *)dat[0].dat;
      if (d)
	 printf("child_dat/msg = '%s'\n", d->dat);
      else
	 printf("child_dat/msg not found!\n");

      unload_datafile(dat);
   }
   else
      printf("Error!\n");

   /* try loading just the child file */
   printf("\nTesting load_datafile(\"test.dat#child_dat\")\n");
   dat = load_datafile("test.dat#child_dat");
   if (dat) {
      printf("msg = '%s'\n", dat->dat);
      unload_datafile(dat);
   }
   else
      printf("Error!\n");

   /* try loading individual objects */
   printf("\nTesting load_datafile_object(\"test.dat\", \"msg\")\n");
   dat = load_datafile_object("test.dat", "msg");
   if (dat) {
      printf("msg = '%s'\n", dat->dat);
      unload_datafile_object(dat);
   }
   else
      printf("Error!\n");

   printf("\nTesting load_datafile_object(\"test.dat\", \"child_dat/msg\")\n");
   dat = load_datafile_object("test.dat", "child_dat/msg");
   if (dat) {
      printf("child_dat/msg = '%s'\n", dat->dat);
      unload_datafile_object(dat);
   }
   else
      printf("Error!\n");

   printf("\nTesting load_datafile_object(\"test.dat#child_dat\", \"child_dat\")\n");
   dat = load_datafile_object("test.dat#child_dat", "msg");
   if (dat) {
      printf("msg = '%s'\n", dat->dat);
      unload_datafile_object(dat);
   }
   else
      printf("Error!\n");

   /* try using packfile syntax */
   printf("\nTesting pack_fopen(\"test.dat#msg\")\n");
   f = pack_fopen("test.dat#msg", F_READ);
   if (f) {
      printf("msg = '");
      c = pack_getc(f);
      while ((c) && (c != EOF)) {
	 putchar(c);
	 c = pack_getc(f);
      }
      printf("'\n");
      pack_fclose(f);
   }
   else
      printf("Error!\n");

   printf("\nTesting pack_fopen(\"test.dat#child_dat/msg\")\n");
   f = pack_fopen("test.dat#child_dat/msg", F_READ);
   if (f) {
      printf("msg = '");
      c = pack_getc(f);
      while ((c) && (c != EOF)) {
	 putchar(c);
	 c = pack_getc(f);
      }
      printf("'\n");
      pack_fclose(f);
   }
   else
      printf("Error!\n");

   printf("\nTesting complete.\n");

   return 0;
}

END_OF_MAIN();
